package ida.pelab.cgn.TextComment;

import java.util.ArrayList;

import cetus.hir.ArrayAccess;
import cetus.hir.Traversable;
import ida.pelab.cgn.ICodeGenerator;
import ida.pelab.cgn.TargetArchitecture;
import ida.pelab.prt.annotation.ArrayAnnotation;
import ida.pelab.prt.pattern.LoopVariable;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.pattern.PatternInstance;
import ida.pelab.prt.pattern.PatternInstanceParameter;
import ida.pelab.prt.pattern.PatternLevel;

public class CommentCodeGenerator implements ICodeGenerator {
	
	private TargetArchitecture architecture;
	@Override
	public TEXTAnotation generateCode(MatchedInstance matchedInstance )
	{
		   PatternInstance instance=matchedInstance.getInstance();
		   String result=instance.getPattern().getOutputSyntax().getPrintingName() +"(";
			ArrayList<PatternInstanceParameter> params= instance.getParameters();
			ArrayList<LoopVariable> loopVariableList= new ArrayList<LoopVariable>();
			
			
			for(int i=0;i<params.size();i++)
			{
				PatternInstanceParameter cuInstace= params.get(i);
				if(cuInstace.isNegated())
					result+="-";
				if (cuInstace.isDivided())
					result+="1/";
				switch (cuInstace.getType()) {
				case Number:
						result+= params.get(i).getTreeNode().toString()+",";
					break;
				case String:
					result+= params.get(i).getStringValue()+ ",";
					break;
				case Identifier:

						result+= params.get(i).getTreeNode().toString()+",";
		
					break;
				case Vector:
						result+= params.get(i).getTreeNode().toString()+",";

					break;				
				case Loopvariable:
					  result+= ((LoopVariable)params.get(i).getTreeNode()).toIndexString()+",";
					  loopVariableList.add((LoopVariable)params.get(i).getTreeNode());
						break;
				case Subscripted:
					
					result+=ArrayAnnotation.toAnnotatedString((ArrayAccess)params.get(i).getTreeNode(),loopVariableList)+",";
						break;
				case nonSubscripted:
					result+= params.get(i).getTreeNode().toString()+",";
					break;
				case Condition: 	
					result+= params.get(i).getTreeNode().toString()+",";
					break;
				default:
					break;
				}
				
				
			}
			if(result.endsWith(","))
				result=result.substring(0,result.length()-1);
			result+=")";
			return new TEXTAnotation(result);
	}

	@Override
	public void runExtraOperation(Traversable irTreeRoot) {
		
	}

	@Override
	public boolean hideCode() {
		// TODO Auto-generated method stub
	return getArchitecture().isShowCode();
	}

	public void setArchitecture(TargetArchitecture architecture) {
		this.architecture = architecture;
	}

	public TargetArchitecture getArchitecture() {
		if(architecture==null)
			architecture=new TextSettingLoader().loadSetting();
		return architecture;
	}

	@Override
	public PatternLevel getLevel() {
		// TODO Auto-generated method stub
		return PatternLevel.Level0;
	}		


}
