package ida.pelab.prt.constraints;



import ida.pelab.prt.pattern.LoopVariable;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.patternhierarchy.AnnotatedTree;
import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;

import cetus.hir.ArrayAccess;
import cetus.hir.ForLoop;
import cetus.hir.Traversable;
public class ArrayIndexCheck extends Constraint {

	
	private String parameterID;
	public String getParameterID() {
		return parameterID;
	}
	public void setParameterID(String parameterID) {
		this.parameterID = parameterID;
	}



	private ArrayList<ArrayList<String>> indices;
	private ArrayList<IndexRuleCheck> indexconstArray;	
	
	public ArrayIndexCheck()
	{
		indices= new ArrayList<ArrayList<String>>(4);
		indexconstArray= new ArrayList<IndexRuleCheck>();
	}
	public ArrayList<ArrayList<String>> getIndices() {
		return indices;
	}



	public void AddIndex(ArrayList<String> variations) {
		indices.add(variations);
	}



	public boolean check(Traversable rootNode,
			ArrayList<MatchedInstance> children) {
		// TODO Auto-generated method stub
		  
		Traversable arrayNode =StructuralComparison.mapParameter(parameterID, children);
		if(arrayNode==null || !(arrayNode instanceof ArrayAccess))
						return false;
		return indexStructureCheck(rootNode,arrayNode) && indexConstraintCheck(rootNode, arrayNode,children);
		}
	
	
	
	private boolean indexStructureCheck(Traversable subTreeRoot,Traversable arrayNode)
	{
		 int j=0;
		 ArrayList<MatchedInstance> children= AnnotatedTree.GetChildrensPattern(arrayNode);		 
		 if(children==null || children.size()<indices.size()+1)
			 return false;
		 for(int i=0; i< indices.size();i++)
			 {
			 	for(j=0; j<indices.get(i).size();j++)			 
			 		if(indices.get(i).get(j).equals(children.get(i+1).getPatternName()))
			 			break;
			 	if(j==indices.get(i).size())
			 		return false;
			 }
		 
		 return true;
	}


	private boolean indexConstraintCheck(Traversable subTreeRoot, Traversable array,ArrayList<MatchedInstance> loweLevelPatterns)
	{
		ArrayList<MatchedInstance> children= AnnotatedTree.GetChildrensPattern(array);
		
		ArrayList<MatchedInstance> searchKeys= new ArrayList<MatchedInstance>();
		for(int i=1;i< children.size();i++)
			searchKeys.add(children.get(i));

		
		
		for(int i =0 ; i< indexconstArray.size();i++)
			{
			 
			   Traversable node=  StructuralComparison.mapParameter(indexconstArray.get(i).getParameters().get(0),searchKeys);
			   Traversable rightSide =mapKeywords(subTreeRoot, indexconstArray.get(i).getParameters().get(1),loweLevelPatterns);
			   RuleCheckOperator op= indexconstArray.get(i).getOperator();
			   switch (op) {
			   case eq:
				        if(!node.equals(rightSide))
				        	return false;
				break;
			   case ne :
				   if(node.equals(rightSide))
			        	return false;
			   			}
			}
		return true;
		
	}
	
	public Traversable mapKeywords(Traversable subtreeRootNode,String refString,ArrayList<MatchedInstance> childrenPattern )
	{
		LoopVariable lp =LoopVariable.buildVariable((ForLoop)subtreeRootNode);
		
		Traversable mappedNode=null;
		if(refString.equals("LV"))
			mappedNode=lp.getVariableExpression();
		else if(refString.equals("LV_LB"))
			mappedNode=lp.getLowerBound();
		else if(refString.equals("LV_UB"))
			mappedNode=lp.getAbsoluteUpperBound();
		else if(refString.startsWith("CP"))
		{
			String mapString= refString.substring(3);
			 if(refString.contains("_LB"))
			 {   
				 mapString= mapString.substring(0,mapString.indexOf("_LB"));
				 Traversable node=  StructuralComparison.mapParameter(mapString,childrenPattern);
				 if(node !=null && node instanceof LoopVariable)
				 mappedNode=((LoopVariable)node).getLowerBound();
			 }
			 else if(refString.contains("_UB"))
			 {				 
					mapString= mapString.substring(0,mapString.indexOf("_UB"));
					Traversable node=  StructuralComparison.mapParameter(mapString,childrenPattern);
					if(node !=null && node instanceof LoopVariable)
						mappedNode=((LoopVariable)node).getAbsoluteUpperBound();				 
			 }
			 else
			 {
				 mappedNode= StructuralComparison.mapParameter(mapString,childrenPattern);
				 if(mappedNode instanceof LoopVariable)
					 mappedNode=((LoopVariable)mappedNode).getVariableExpression();
			 }
			 
		}
			 
		return mappedNode;
	}
	
	public void addIndexconstraint(IndexRuleCheck constraint) {
		indexconstArray.add(constraint);
	}



	public ArrayList<IndexRuleCheck> getIndexconstArray() {
		return indexconstArray;
	}
	

	
	
}
