package ida.pelab.prt.constraints;

import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;


import cetus.hir.CompoundStatement;
import cetus.hir.IfStatement;
import cetus.hir.Statement;
import cetus.hir.Traversable;

public class IFStructureCheck extends Constraint {

	private ArrayList<String> thenNodes;
	private ArrayList<String> elseNodes;
	
   public IFStructureCheck() {
	    thenNodes=new ArrayList<String>();
	    elseNodes= new ArrayList<String>();
  }
   
   public void AddtoThenStructure(String statement)
   {
	   thenNodes.add(statement);
   }
   
   
   public void AddtoELseStructure(String statement)
   {
   elseNodes.add(statement);
   }
   
   
   public boolean check(Traversable rootnode, ArrayList<MatchedInstance> nodelist )
	{
	   IfStatement ifnode =(IfStatement) rootnode;
	   if(thenNodes.size()>0)
	   {
		   CompoundStatement thenBody=(CompoundStatement)ifnode.getThenStatement();
		   for(int i=0;i<thenNodes.size();i++)
			   	{
			   	   Traversable node=StructuralComparison.mapParameter(thenNodes.get(i), nodelist);
			   	   if( !(node instanceof Statement) )
			   		   node=node.getParent();
			   	   if(!(thenBody.getChildren().size()>i && thenBody.getChildren().get(i).equals(node)))
			   		   return false;
			   	}
		   
	   }
	   if(elseNodes.size()>0)
	   {
		   CompoundStatement elseBody=(CompoundStatement)ifnode.getElseStatement();
		   for(int i=0;i<elseNodes.size();i++)
			   	{
			   	   Traversable node=StructuralComparison.mapParameter(elseNodes.get(i), nodelist);
			   	   if( !(node instanceof Statement) )
			   		   node=node.getParent();
			   	   if(!(elseBody.getChildren().size()>i && elseBody.getChildren().get(i).equals(node)))
			   		   return false;
			   	}
		   
	   }
	   return true;
	}
   
   
}
