package ida.pelab.prt.constraints;

import ida.pelab.prt.pattern.LoopVariable;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;



import cetus.hir.Traversable;

public class RuleCheck extends Constraint {
	
	
	RuleCheckOperator  operator;
	ArrayList<String> parameters;
	public RuleCheckOperator getOperator() {
		return operator;
	}
	public void setOperator(RuleCheckOperator operator) {
		this.operator = operator;
	}
	public ArrayList<String> getParameters() {
		return parameters;
	}
	public void setParameters(ArrayList<String> parameters) {
		this.parameters = parameters;
	}
	public RuleCheck(RuleCheckOperator operator, ArrayList<String> parameters) {
		super();
		this.operator = operator;
		this.parameters = parameters;
	}
	
	
	public boolean check(Traversable node, ArrayList<MatchedInstance> nodelist )
	{
		Traversable firstNode= StructuralComparison.mapParameter(getParameters().get(0), nodelist);
		Traversable secondNode= StructuralComparison.mapParameter(getParameters().get(1), nodelist);
		if(firstNode==null || secondNode==null)
			return false;
				
	   switch (operator) {
	   
	   case eq:
		   if(firstNode instanceof LoopVariable && secondNode instanceof LoopVariable)
			   return LoopVariable.SymbolicComparison((LoopVariable)firstNode, (LoopVariable)secondNode);	   
		   else return  firstNode.equals(secondNode);
	   case ne:
		   return  !firstNode.equals(secondNode);
	
	   default: return false;
	   }
	}
	   
}
